Bug 30236 - Add new keymap that extends USA map with Indian rupee sign
Add new keymap that extends USA map with Indian rupee sign
Status: RESOLVED FIXED
Product: xkeyboard-config
Classification: Unclassified
Component: General
unspecified
Other All
: medium normal
Assigned To: xkb
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-09-17 01:56 UTC by Parag
Modified: 2010-09-29 14:12 UTC (History)
1 user (show)

See Also:


Attachments
Add keymap that will extend USA map with Indian Rupee (3.07 KB, patch)
2010-09-17 01:57 UTC, Parag
Details | Splinter Review
Add keymap that will extend USA map with Indian Rupee (2.46 KB, patch)
2010-09-20 01:24 UTC, Parag
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Parag 2010-09-17 01:56:09 UTC
Hi,
   Recently Indian rupee sign is approved by Unicode. Its discussion is already happened on their mailing list. See http://en.wikipedia.org/wiki/Indian_rupee_sign#Unicode

   I have added new keymap in "symbols/in" file that will extend USA map and will add this rupee sign on AltGr+4

   Therefore, requesting to add this keymap in upcoming upstream release.
Comment 1 Parag 2010-09-17 01:57:25 UTC
Created attachment 38755 [details] [review]
Add keymap that will extend USA map with Indian Rupee
Comment 2 Sergey V. Udaltsov 2010-09-17 14:03:01 UTC
You are adding both option and special variant, just for that option. Is that right? I do not like that.

What I propose is the following: let's add only XKB option. And in base.xml, let's combine eurosign and rupeesign under the same tree: "National currency characters".

What do you think?
Comment 3 Parag 2010-09-20 01:23:03 UTC
I just followed what I saw about Euro sign in source code. What is difference between adding as a option and group?
Comment 4 Parag 2010-09-20 01:24:21 UTC
Created attachment 38808 [details] [review]
Add keymap that will extend USA map with Indian Rupee

I have removed group adding code.
Comment 5 Sergey V. Udaltsov 2010-09-20 12:56:42 UTC
The group is more "namespace" thing. Your last patch is ok - except I'd prefer not to create in(rupee) symbols - let people use rupeesign option if they want.

Since we're currently in freeze, your patch will go into the next release, will be committed after I release 2.0 (next Tuesday)
Comment 6 Parag 2010-09-20 23:45:22 UTC
(In reply to comment #5)
> The group is more "namespace" thing. Your last patch is ok - except I'd prefer
> not to create in(rupee) symbols - let people use rupeesign option if they want.

Sorry can you please explain what above mean? Do you need some more changes in patch?

> 
> Since we're currently in freeze, your patch will go into the next release, will
> be committed after I release 2.0 (next Tuesday)

Ok. I thought it would have been good if this patch is included with other nbsp fix in 2.0 release.
Comment 7 Sergey V. Udaltsov 2010-09-21 02:00:33 UTC
> Sorry can you please explain what above mean? Do you need some more changes in
> patch?
Yes. In base.xml.in, I'd change "euro" options group to "currency" group (with euro:* and rupeesign:4 options).
I would not change symbols/in (and would not add in(rupee) variant to base.xml.in).

> Ok. I thought it would have been good if this patch is included with other nbsp
> fix in 2.0 release.
nbsp fix was there for quite a while, it will be in 2.0 (it is critical fix anyway, not breaking the freeze on rules subdir).
The rupee patch will go to 2.1
Comment 8 Parag 2010-09-21 03:00:21 UTC
(In reply to comment #7)
> > Sorry can you please explain what above mean? Do you need some more changes in
> > patch?
> Yes. In base.xml.in, I'd change "euro" options group to "currency" group (with
> euro:* and rupeesign:4 options).
> I would not change symbols/in (and would not add in(rupee) variant to
> base.xml.in).
> 
  I see eurosign:4 option already present in base.xml.in file. will adding rupeesign:4 place euro and rupee sign on same key?
  When tried to add rupeesign option to us map, the UI seems confusing as I got 2 checkboxes with label "4". Also, as requested need AltGr+4 to provide rupeesign. 
I think then I need to enable another option "ALT_R"
Comment 9 Sergey V. Udaltsov 2010-09-21 15:04:08 UTC
>   I see eurosign:4 option already present in base.xml.in file. will adding
> rupeesign:4 place euro and rupee sign on same key?
No, they will be different XKB options.

>   When tried to add rupeesign option to us map, the UI seems confusing as I got
> 2 checkboxes with label "4". Also, as requested need AltGr+4 to provide
> rupeesign. 
I understand. We'll change the desciption: Euro at 4, Euro at E, Euro at 5, Rupee at 4.
Comment 10 Jens Petersen 2010-09-22 21:22:31 UTC
Sergey, so how do you propose to deal with this new
layout for India?  Though it is largely based on USA
layout there are two changes (adding RupeeSign and
addition of AltGr) - this layout is going to be the
default layout for all India locales instead of current
USA, so there needs to be an easy way to set this layout
and it should definitely appear under India layouts
in the GUI.(
Comment 11 Parag 2010-09-22 23:48:54 UTC
Also, as per http://en.wikinews.org/wiki/India_approves_symbol_for_currency, rupee sign will be added to Keyboards for easy use
Comment 12 Sergey V. Udaltsov 2010-09-23 11:49:21 UTC
> Sergey, so how do you propose to deal with this new
> layout for India?  Though it is largely based on USA
> layout there are two changes (adding RupeeSign and
> addition of AltGr) - this layout is going to be the
> default layout for all India locales instead of current
> USA, 
Wait a sec. This is getting very serious. What you are saying is that new variant in symbols/in (essentially 'us' + small additions) is going to be the default variant for India. Right? Does it mean that all/most keyboard sold in India have corresponding engravings?

My idea was just to add XKB option, so any layout (us,fr,ru,...) could be 'rupee-enabled' with a single checkbox. That would eliminate the need in special variant. But if you're escalating the case to the higher level (changing the default variant for India), we can discuss that.

Also, currently the default variant for India is Devangari
Comment 13 Parag 2010-09-28 00:22:15 UTC
> Wait a sec. This is getting very serious. What you are saying is that new
> variant in symbols/in (essentially 'us' + small additions) is going to be the
> default variant for India. Right? Does it mean that all/most keyboard sold in
> India have corresponding engravings?
> 
Yes. It will be.

> My idea was just to add XKB option, so any layout (us,fr,ru,...) could be
> 'rupee-enabled' with a single checkbox. That would eliminate the need in
> special variant. But if you're escalating the case to the higher level
> (changing the default variant for India), we can discuss that.
> 
> Also, currently the default variant for India is Devangari

yes default variant for India is Devanagari currently.

Just got the information that Government of India will take some time(can be six months) to officially release it. Can it be possible to add new keymap that adds rupeesign as "India - Latin (experimental)" till we get its official release?

Its ok if we at least get this under list of India keymaps but not as default variant for now. Later on we can make this as default.
Comment 14 Sergey V. Udaltsov 2010-09-29 14:12:52 UTC
Ok, I have committed your patch. And polished it a bit:

http://cgit.freedesktop.org/xkeyboard-config/commit/?id=396de5b7138f25e49f4de3a0c871f09f08619867

Hope you do not mind me changing some bits?